local WeaponUp = CreateFrame("Frame")
local items = 	{46106, --Argent Lance
				46069, --Alliance Lance
				46070, --Horde Lance
				37892, --Green Brewfest Stein
				32912, --Yellow Brewfest Stein
				33016, --Blue Brewfest Stein
				44731, --Bouquet of Ebon Roses
				22206} --Bouquet of Red Roses
local fishingpoles = 	{6365, -- Strong Fishing Pole
						46337, -- Staats' Fishing Pole
						52678, -- Jonathan's Fishing Pole
						6256, -- Fishing Pole
						6366, -- Darkwood Fishing Pole
						6367, -- Big Iron Fishing Pole
						25978, -- Seth's Graphite Fishing Pole
						19022, -- Nat Pagles Extreme Angler FC-5000
						45858, -- Nat's Lucky Fishing Pole
						45992, -- Jeweled Fishing Pole
						45991, -- Bone Fishing Pole
						19970, -- Arcanite Fishing Pole
						44050,} -- Mastercraft Kalu'ak Fishing Pole
local fishing = fishing
local queueset = queueset

WeaponUp:RegisterEvent("ADDON_LOADED")
WeaponUp:RegisterEvent("PLAYER_REGEN_DISABLED")
WeaponUp:RegisterEvent("PLAYER_ENTERING_WORLD")
WeaponUp:RegisterEvent("UNIT_INVENTORY_CHANGED")
WeaponUp:RegisterEvent("UI_ERROR_MESSAGE")
WeaponUp:RegisterEvent("UNIT_EXITED_VEHICLE")
WeaponUp:RegisterEvent("EQUIPMENT_SWAP_FINISHED")
WeaponUp:RegisterEvent("PLAYER_REGEN_ENABLED")

SLASH_WeaponUp1 = "/wu";
local function handler(msg, editbox)
	if (msg=="off") then
		wuenable = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cffff0000Off|r")
	
	elseif (msg=="on") then
		wuenable = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cff00ff00On|r")
	
	elseif (msg=="dismount off") then
		wudismount = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Dismount |cffff0000Off|r")
	
	elseif (msg=="dismount on") then
		wudismount = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Dismount |cff00ff00On|r")
		
	elseif (msg=="fishing off") then
		wufishingmode = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Fishing mode |cffff0000Off|r")
	
	elseif (msg=="fishing on") then
		wufishingmode = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Fishing mode |cff00ff00On|r")	
	
	elseif (msg=="help" or msg =="") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r Version |cff00ff003.02|r")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable equips type /wu on or /wu off.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable weapon re-equip on dismount type /wu dismount on or /wu dismount off.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable fishing mode type /wu fishing on or /wu fishing off.")
	
	elseif msg then
		wuname = msg
		wulastset = msg
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponUp:|r Current set |cff00ff00 %s|r", msg ))
	end
end
SlashCmdList["WeaponUp"] = handler;

local function DoEquip() -- equip function
local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	for i,v in pairs(items) do
		if IsEquippedItem(v) then
			UseEquipmentSet(wuname)
		end
	end
	for i,v in pairs(fishingpoles) do
		if IsEquippedItem(v) then
			UseEquipmentSet(wuname)
		end
	end
	
	if not mainHandLink then 
		UseEquipmentSet(wuname)
	
	elseif mainHandLink then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
		if (itemRarity == 0 or itemRarity == 1) then --Gray and white level items
			UseEquipmentSet(wuname)
		end
	
	elseif secondaryHandLink then
		local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
		if (itemRarity2 == 0 or itemRarity2 == 1) then --Gray and white level items
			UseEquipmentSet(wuname)
		end
	end
end

local function CheckSet() -- see what weapons we currently have on
	for i,v in ipairs(items) do
		if IsEquippedItem(v) then
			return;
		end
	end
	for i,v in ipairs(fishingpoles) do
		if IsEquippedItem(v) then
			if not UnitAffectingCombat("player") then
				wufishingname = wulastset	-- set fishing set name
				fishing = true -- manually equipped fishing set
				
			end
			return;
		end
	end
	-----determine if wielding a suitable weapon-----
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	if mainHandLink then
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
			if not UnitAffectingCombat("player") and (itemRarity ~= nil or itemRarity ~= 0 or itemRarity ~= 1) then
				wuname = wulastset -- set set name
				fishing = nil -- manually equipped a suitable set, disable fishing
			end
	end
	if secondaryHandLink then
	local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
			if not UnitAffectingCombat("player") and (itemRarity2 ~= nil or itemRarity2 ~= 0 or itemRarity2 ~= 1) then
				wuname = wulastset -- set set name
				fishing = nil	-- manually equipped a suitable set, disable fishing
			end
	end
end

local function eventHandler(self, event, ...)

if event == "ADDON_LOADED" then
local addon = ...
	if addon == "WeaponUp" then
		if not wuname then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r No set detected. Please equip a gearset with the Equipment Manager or type /wu and the exact name of the gearset you want to use for this addon to work.")
		end
	end

elseif event == "PLAYER_REGEN_DISABLED" then -- entered combat, equip a weapon if no suitable weapon
	if not wuname or wuenable == false or UnitInVehicle("player") then
		return;
	else
		DoEquip()
	end
	
elseif event == "UNIT_INVENTORY_CHANGED" then -- gear has changed
local unit = ...
	if (unit ~= "player")  or wuenable == false then
		return;
	end
	CheckSet()

elseif event == "PLAYER_ENTERING_WORLD" then
	if wuenable == false then
		return;
	end
	local inInstance, instanceType = IsInInstance()
	CheckSet()
	if wuname and inInstance == 1 then -- set determined and zoned into an instance
		DoEquip()
	end

elseif event == "EQUIPMENT_SWAP_FINISHED" then -- finished equipping a gearset
local ok, name = ...
	if wuenable == false then 
		return;
	end
	if (ok == true) and UnitAffectingCombat("player") and wuname and not UnitInVehicle("player") then
		RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched to set |cff00ff00 %s|r", name ), ChatTypeInfo["RAID_WARNING"] );
	elseif (ok == false) and UnitAffectingCombat("player") and wuname and not UnitInVehicle("player") then
		RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Could not switch to set |cff00ff00 %s|r", name ), ChatTypeInfo["RAID_WARNING"] );
		queueset = true --couldn't swap so queue set
	end
	wulastset = name

-------- Argent Tournament related functions ----------
elseif event == "UI_ERROR_MESSAGE" then 
local message = ...
	if wuenable == false or UnitAffectingCombat("player") then
		return
	end
	if message == "You must have a lance equipped." and not IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070) then
		if GetItemCount(46106) > 0 then
			EquipItemByName(46106)
		elseif GetItemCount(46069) > 0 then
			EquipItemByName(46069)
		elseif GetItemCount(46070) > 0 then
			EquipItemByName(46070)
		elseif GetItemCount(46106) == 0 and GetItemCount(46069) == 0 and GetItemCount(46070) == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r You do not have a lance in your bags.")
		end
	end

elseif event == "UNIT_EXITED_VEHICLE" then
local unit = ...
	if not wuname or wuenable == false or UnitInVehicle("player") or unit ~= "player" then
		return;
	end
	if wudismount == true and unit == "player" and not UnitAffectingCombat("player") then
		if IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070) then -- Was in an Argent vehicle
			UseEquipmentSet(wuname)
		end
	end

elseif event == "PLAYER_REGEN_ENABLED" then
	if not wuname or wuenable == false or UnitInVehicle("player") then
		return;
	end	
	local inInstance, instanceType = IsInInstance()
	if wudismount == true then
		if IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070) then -- Was in an Argent vehicle
			UseEquipmentSet(wuname)
		end
	end	
	if wufishingmode == true then
		if inInstance == nil and fishing == true then
			for i,v in ipairs(fishingpoles) do
				if IsEquippedItem(v) then -- fishing pole equipped do nothing
					return;
				end
			end
			UseEquipmentSet(wufishingname) -- no fishing pole, re-equip fishing set
			RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched back to set |cff00ff00 %s|r", wufishingname ), ChatTypeInfo["RAID_WARNING"] );	
		end
	end
	if queueset == true then -- set couldn't be equipped so do so now
		if wufishingmode == true then
			for i,v in ipairs(fishingpoles) do	
				if IsEquippedItem(v) then
					queueset = nil --fishing set is already on do nothing
				end
			end
		else
			UseEquipmentSet(wuname)
			RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched to set |cff00ff00 %s|r", wuname ), ChatTypeInfo["RAID_WARNING"] );
			queueset = nil --set equipped clear queued set
		end
	end
end
end
WeaponUp:SetScript("OnEvent", eventHandler)